better error output
[automated-distro-installer] / fai-redep
index 8ff1df2c9b2f284b0c9e9900acf4c8e38835be5c..cd0888737541a0d475d7de19df177b193ee3fbf2 100755 (executable)
--- a/fai-redep
+++ b/fai-redep
@@ -1,26 +1,46 @@
-#!/bin/bash -lx
+#!/bin/bash -l
+set -x
 
 # Deploy fai configuration to faiserver,
 # then start a virtual machine to test the config.
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
-ssh root@faiserver rm -rf /srv/fai/config/\*
-scp -r /a/bin/fai/fai/config root@faiserver:/srv/fai
-ssh root@faiserver tee -a /srv/fai/config/class/DESKTOP.var <<EOF
-ROOTPW='$(cat /p/shadow/standard)'
+cd $(dirname $(readlink -f "$BASH_SOURCE"))
+
+ssh root@faiserver rm -rf /srv/fai/config
+scp -r fai/config root@faiserver:/srv/fai
+# fai example pass: fai
+#ROOTPW='$1$kBnWcO.E$djxB128U7dMkrltJHPf6d1'
+
+# generating a hashed password:
+# under debian, you can do
+# echo "yoursecrectpassword" | mkpasswd -m sha-512 -s
+# On arch, best seems to be copy your shadow file to a temp location,
+# then passwd, get out the new pass, then copy the shadow file back.
+
+f=/q/root/shadow/standard
+if s test -e $f; then
+    ssh root@faiserver tee -a /srv/fai/config/class/DEFAULT.var <<EOF
+ROOTPW='$(s cat $f)'
+EOF
+fi
+
+tpvar="$(s cat /q/root/shadow/traci-simple)"
+ssh root@faiserver tee -a /srv/fai/config/class/tp.var <<EOF
+ROOTPW='$tpvar'
 EOF
+
 scp ~/.ssh/id_rsa.pub \
-    root@faiserver:/srv/fai/config/files/home/ian/.ssh/authorized_keys/DESKTOP
-s scp -r /q/root/luks root@faiserver:/srv/fai/config/distro-install-common
-ssh root@faiserver chmod -R a+r /srv/fai/config/distro-install-common
-
-s virshrm demohost ||:
-# this one doesn't need to be done every time
-s qemu-img create -o preallocation=metadata -f qcow2 \
-  /var/lib/libvirt/images/demohost 30G
-s qemu-img create -o preallocation=metadata -f qcow2 \
-  /var/lib/libvirt/images/demohostb 30G
-# osinfo-query os | gr jessie
-s virt-install --os-variant debian8 --cpu host -n demohost --pxe -r 2048 --vcpus 1 --disk path=/var/lib/libvirt/images/demohost   -w bridge=br0,mac=52:54:00:9c:ef:ad
+    root@faiserver:/srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+# todo: automatically disable faiserver after a period so
+# these files are not exposed.
+s scp -r /q/root/luks /q/root/shadow/traci{,-simple} \
+  root@faiserver:/srv/fai/config/distro-install-common
+scp /a/bin/devbyid root@faiserver:/srv/fai/nfsroot/usr/local/bin
+ssh root@faiserver bash <<'EOF'
+set -eE -o pipefail
+chmod 644 /srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+chmod -R a+rX /srv/fai/config/distro-install-common
+EOF